<template>
    <div>
        <div v-if="histories.data.length && shop">
            <div class="table-title">
                History
            </div>
            <div class="table-responsive">
                <table class="table-hover">
                    <thead class="table-header">
                        <tr>
                            <th class="table-first-item">
                                Text
                            </th>
                            <th>Sent date</th>
                            <th>Status</th>
                            <th>Sent</th>
                            <th>Clicked</th>
                            <th>CTR (%)</th>
                            <th>Orders</th>
                            <th>CVR, %</th>
                            <th>Revenue</th>
                            <th>Cost</th>
                            <th>ROI, %</th>
                        </tr>
                    </thead>
                    <tbody class="table-body">
                        <tr
                            v-for="(history, index) in histories.data"
                            :key="index"
                            class="table-body-row"
                        >
                            <th class="table-first-item">
                                {{ history.body_text.length >= 50?history.body_text.slice(0, 50) + '...' : history.body_text }}
                            </th>
                            <th>{{ history.schedule_datetime }}</th>
                            <th>
                                <div
                                    v-if="history.status === 'completed'"
                                    class="table-status-complete"
                                >
                                    Completed
                                </div>
                                <div
                                    v-if="history.status === 'in_progress'"
                                    class="table-status-process"
                                >
                                    In Progress
                                </div>
                                <div
                                    v-if="history.status === 'insufficient_funds'"
                                    class="table-status-failed"
                                >
                                    Insufficient funds
                                </div>
                            </th>
                            <th>{{ history.send_count }}</th>
                            <th>{{ history.clicks_count }}</th>
                            <th>{{ history.click_rate }} %</th>
                            <th>{{ history.orders_count }}</th>
                            <th>{{ history.cvr }} %</th>
                            <th>{{ history.revenue }} {{ getCurrencySign.symbol_native }}</th>
                            <th style="white-space: nowrap;">
                                {{ history.cost }} $
                            </th>
                            <th>{{ history.roi }} %</th>
                        </tr>
                    </tbody>
                </table>
            </div>
            <pagination
                :data="histories"
                @pagination-change-page="getResults"
            />
        </div>
        <div
            v-else
            class="row row-container"
        >
            <div class="col-md-8">
                Your Campaign history will appear here
            </div>
            <div class="col-md-4 not-found">
                You have no <span>History</span>
            </div>
        </div>
    </div>
</template>

<script>
    import smsCampaign from '../../../mixins/sms/campaigns.service';
    import currencies from "../../../data/currencies.json";
    import shop from '../../../mixins/shop.service'

    export default {
        name: "HistoriesTable",
        mixins: [smsCampaign, shop],
        data() {
            return {
                currencies: currencies,
                histories: {data: []}
            };
        },
        computed: {
            getCurrencySign() {
                if (!this.currencies) {
                    return {
                        symbol: this.shop.payment_currency
                    };
                }
                return this.currencies[this.shop.payment_currency];
            }
        },
        mounted() {
            this.getResults();
        },
        created() {
            this.loadShop()
        },
        methods: {
            async loadShop() {
                this.shop = await this.getShop();
            },
            getResults(pageNum = 1, perPage = 5) {
                this.getAllHistories(pageNum, perPage).then(response => (this.histories = response.data)).catch(error => {
                    console.log(error)
                });
            },
        }
    };
</script>
<style scoped lang="scss">


.table-title {
    font-size: 28px;
    font-weight: bold;
    margin-left: 13px;
    margin-top: 45px;
}

.row-container {
    margin-top: 40px;
}

.not-found {
    font-size: 18px;
    color: #b3b9c4;
    font-weight: 900;
    text-align: right;
}

.table-status-complete {
    color: #2BB300;
}
.table-status-failed {
    color: #e9000f;
}
.not-found span {
    color: #03183B;
}

.campaigns-title {
    font-size: 28px;
    font-weight: bold;
}

.subtitle {
    font-size: 11px;
}

.title-container {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 25px;
    @media screen and (max-width: 500px) {
        flex-direction: column;
        align-items: baseline;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 15px;
    }
}

.my-icon {
    color: white;
    margin-right: 8px;
    font-size: 17px;
}

.table-first-item {
    text-align: start !important;
}

.table-hover tr {
    border-bottom: 3px solid #F5F6FA;
    border-radius: 10px;
}

.table-header {
    padding: 10px;
}

.table-body {
    background: white;
    border-radius: 10px;
}

.table-hover tbody tr:hover {
    background-color: #fbfcfd;
}
.table-hover {
    min-width: 1080px;
}

</style>
